from typing import Dict

from zope.interface import Interface

from .IUser import IUser


class IMailService(Interface):
    """An interface to send email messages."""

    def send(_from: str, to: str, headers: Dict[str, str], content: str):
        """Send a message with the given headers and content."""

    def send_welcome_message_to(user: IUser):
        """Send a welcome message to the new member."""
